/* A Bison parser, made by GNU Bison 1.875.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     NUM = 258,
     VAR = 259,
     STR = 260,
     INPUT = 261,
     PRINTLN = 262,
     PRINT = 263,
     QUIT = 264,
     HELP = 265,
     FUNCTIONS = 266,
     CONSTANTS = 267,
     VARIABLES = 268,
     INV_IMPLIES = 269,
     IMPLIES = 270,
     OR = 271,
     XOR = 272,
     AND = 273,
     NOT = 274,
     NOT_EQUALS = 275,
     EQUALS = 276,
     SHR = 277,
     SHL = 278,
     ARCTAN = 279,
     ARCCOS = 280,
     ARCSIN = 281,
     TANH = 282,
     COSH = 283,
     SINH = 284,
     TAN = 285,
     COS = 286,
     SIN = 287,
     EXP = 288,
     ROUND = 289,
     FLOOR = 290,
     CEIL = 291,
     LOG = 292,
     LN = 293,
     CBRT = 294,
     SQRT = 295,
     ABS = 296,
     NEG = 297
   };
#endif
#define NUM 258
#define VAR 259
#define STR 260
#define INPUT 261
#define PRINTLN 262
#define PRINT 263
#define QUIT 264
#define HELP 265
#define FUNCTIONS 266
#define CONSTANTS 267
#define VARIABLES 268
#define INV_IMPLIES 269
#define IMPLIES 270
#define OR 271
#define XOR 272
#define AND 273
#define NOT 274
#define NOT_EQUALS 275
#define EQUALS 276
#define SHR 277
#define SHL 278
#define ARCTAN 279
#define ARCCOS 280
#define ARCSIN 281
#define TANH 282
#define COSH 283
#define SINH 284
#define TAN 285
#define COS 286
#define SIN 287
#define EXP 288
#define ROUND 289
#define FLOOR 290
#define CEIL 291
#define LOG 292
#define LN 293
#define CBRT 294
#define SQRT 295
#define ABS 296
#define NEG 297




/* Copy the first part of user declarations.  */
#line 3 "h3calc-bison.y"

#include <stdio.h>
#include <math.h>
#include <strings.h>
#include "h3calc-shared.h"	/* macro e funzioni condivise */


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
typedef int YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 177 "h3calc-bison.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1088

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  61
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  5
/* YYNRULES -- Number of rules. */
#define YYNRULES  62
/* YYNRULES -- Number of states. */
#define YYNSTATES  151

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   297

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      60,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    57,     2,     2,     2,    32,     2,     2,
      58,    59,    30,    28,    15,    29,     2,    31,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    34,     2,
      24,    14,    25,    35,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    33,     2,    36,    55,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    16,
      17,    18,    19,    20,    21,    22,    23,    26,    27,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    56
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned char yyprhs[] =
{
       0,     0,     3,     4,     7,     9,    12,    16,    18,    20,
      22,    24,    26,    29,    32,    34,    36,    38,    42,    44,
      46,    48,    52,    56,    60,    64,    68,    71,    75,    79,
      83,    87,    92,    97,   101,   105,   109,   113,   117,   121,
     125,   128,   132,   135,   139,   147,   152,   157,   162,   167,
     172,   177,   182,   187,   192,   197,   202,   207,   212,   217,
     222,   227,   232
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      62,     0,    -1,    -1,    62,    63,    -1,    60,    -1,    65,
      60,    -1,     4,    14,    65,    -1,     9,    -1,    13,    -1,
      12,    -1,    10,    -1,    11,    -1,     8,    64,    -1,     7,
      64,    -1,     7,    -1,     5,    -1,     4,    -1,    64,    15,
      64,    -1,     3,    -1,     4,    -1,     6,    -1,    65,    20,
      65,    -1,    65,    18,    65,    -1,    65,    19,    65,    -1,
      65,    17,    65,    -1,    65,    16,    65,    -1,    21,    65,
      -1,    65,    27,    65,    -1,    65,    26,    65,    -1,    65,
      24,    65,    -1,    65,    25,    65,    -1,    65,    24,    14,
      65,    -1,    65,    25,    14,    65,    -1,    65,    23,    65,
      -1,    65,    22,    65,    -1,    65,    28,    65,    -1,    65,
      29,    65,    -1,    65,    30,    65,    -1,    65,    31,    65,
      -1,    65,    32,    65,    -1,    29,    65,    -1,    65,    55,
      65,    -1,    65,    57,    -1,    58,    65,    59,    -1,    33,
      65,    35,    65,    34,    65,    36,    -1,    49,    58,    65,
      59,    -1,    48,    58,    65,    59,    -1,    47,    58,    65,
      59,    -1,    46,    58,    65,    59,    -1,    54,    58,    65,
      59,    -1,    45,    58,    65,    59,    -1,    44,    58,    65,
      59,    -1,    43,    58,    65,    59,    -1,    42,    58,    65,
      59,    -1,    41,    58,    65,    59,    -1,    40,    58,    65,
      59,    -1,    39,    58,    65,    59,    -1,    38,    58,    65,
      59,    -1,    37,    58,    65,    59,    -1,    53,    58,    65,
      59,    -1,    52,    58,    65,    59,    -1,    51,    58,    65,
      59,    -1,    50,    58,    65,    59,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,    66,    66,    67,    70,    71,    72,    77,    78,    83,
      88,   109,   118,   119,   120,   124,   125,   134,   140,   141,
     151,   156,   160,   164,   170,   174,   178,   182,   186,   190,
     194,   198,   202,   206,   210,   214,   215,   216,   217,   218,
     219,   220,   221,   228,   229,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     255,   262,   269
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "NUM", "VAR", "STR", "INPUT", "PRINTLN", 
  "PRINT", "QUIT", "HELP", "FUNCTIONS", "CONSTANTS", "VARIABLES", "'='", 
  "','", "INV_IMPLIES", "IMPLIES", "OR", "XOR", "AND", "NOT", 
  "NOT_EQUALS", "EQUALS", "'<'", "'>'", "SHR", "SHL", "'+'", "'-'", "'*'", 
  "'/'", "'%'", "'['", "':'", "'?'", "']'", "ARCTAN", "ARCCOS", "ARCSIN", 
  "TANH", "COSH", "SINH", "TAN", "COS", "SIN", "EXP", "ROUND", "FLOOR", 
  "CEIL", "LOG", "LN", "CBRT", "SQRT", "ABS", "'^'", "NEG", "'!'", "'('", 
  "')'", "'\\n'", "$accept", "input", "line", "string", "exp", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    61,    44,   269,   270,   271,   272,
     273,   274,   275,   276,    60,    62,   277,   278,    43,    45,
      42,    47,    37,    91,    58,    63,    93,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,    94,   297,    33,    40,    41,
      10
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    61,    62,    62,    63,    63,    63,    63,    63,    63,
      63,    63,    63,    63,    63,    64,    64,    64,    65,    65,
      65,    65,    65,    65,    65,    65,    65,    65,    65,    65,
      65,    65,    65,    65,    65,    65,    65,    65,    65,    65,
      65,    65,    65,    65,    65,    65,    65,    65,    65,    65,
      65,    65,    65,    65,    65,    65,    65,    65,    65,    65,
      65,    65,    65
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     0,     2,     1,     2,     3,     1,     1,     1,
       1,     1,     2,     2,     1,     1,     1,     3,     1,     1,
       1,     3,     3,     3,     3,     3,     2,     3,     3,     3,
       3,     4,     4,     3,     3,     3,     3,     3,     3,     3,
       2,     3,     2,     3,     7,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       2,     0,     1,    18,    19,    20,    14,     0,     7,    10,
      11,     9,     8,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     4,     3,     0,     0,    16,
      15,    13,    12,    19,    26,    40,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    42,     5,     6,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    43,    25,    24,    22,
      23,    21,    34,    33,     0,    29,     0,    30,    28,    27,
      35,    36,    37,    38,    39,    41,    17,     0,    58,    57,
      56,    55,    54,    53,    52,    51,    50,    48,    47,    46,
      45,    62,    61,    60,    59,    49,    31,    32,     0,     0,
      44
};

/* YYDEFGOTO[NTERM-NUM]. */
static const yysigned_char yydefgoto[] =
{
      -1,     1,    36,    41,    37
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -47
static const short yypact[] =
{
     -47,   104,   -47,   -47,     0,   -47,     5,     8,   -47,   -47,
     -47,   -47,   -47,   263,   263,   263,   -43,   -42,   -41,   -40,
     -39,   -38,   -36,   -35,   -34,   -32,   -31,   -30,   -29,   -28,
     -26,    -6,    12,    13,   263,   -47,   -47,    67,   263,   -47,
     -47,    57,    57,   -47,  1031,    16,   872,   263,   263,   263,
     263,   263,   263,   263,   263,   263,   263,   263,   263,   263,
     263,   263,   263,   263,   263,   306,   263,   263,   263,   263,
     263,   263,   263,   157,   210,   263,   263,   263,   263,   263,
     263,   263,   263,   -47,   -47,   956,     8,   263,   323,   367,
     384,   428,   445,   489,   506,   550,   567,   611,   628,   672,
     689,   733,   750,   794,   811,   855,   -47,   974,   974,   995,
    1010,  1031,   892,  1017,   263,  1017,   263,  1017,   -24,   -24,
      45,    45,   -46,   -46,   -46,   -46,   -47,   914,   -47,   -47,
     -47,   -47,   -47,   -47,   -47,   -47,   -47,   -47,   -47,   -47,
     -47,   -47,   -47,   -47,   -47,   -47,   956,   956,   263,   934,
     -47
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
     -47,   -47,   -47,    -4,   -13
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned char yytable[] =
{
      44,    45,    46,    42,    77,    78,    79,    80,    81,    82,
      40,    83,    39,    40,    38,    47,    48,    49,    50,    51,
      52,    65,    53,    54,    55,    85,    56,    57,    58,    59,
      60,    82,    61,    83,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,    62,   107,   108,   109,   110,   111,   112,   113,
     115,   117,   118,   119,   120,   121,   122,   123,   124,   125,
      63,    64,    86,    83,   127,    79,    80,    81,     0,     0,
       0,     0,   126,    66,    67,    68,    69,    70,     0,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,   146,    83,   147,     2,     0,     0,     3,     4,     0,
       5,     6,     7,     8,     9,    10,    11,    12,     0,     0,
       0,     0,    82,     0,    83,    13,     0,    84,     0,     0,
       0,     0,     0,    14,     0,   149,     0,    15,     0,     0,
       0,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,     0,
       3,    43,    34,     5,    35,     0,     0,     0,     0,     0,
       0,   114,     0,     0,     0,     0,     0,     0,    13,     0,
       0,     0,     0,     0,     0,     0,    14,     0,     0,     0,
      15,     0,     0,     0,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,     0,     3,    43,    34,     5,     0,     0,     0,
       0,     0,     0,     0,   116,     0,     0,     0,     0,     0,
       0,    13,     0,     0,     0,     0,     0,     0,     0,    14,
       0,     0,     0,    15,     0,     0,     0,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,     0,     3,    43,    34,     5,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    13,     0,     0,     0,     0,     0,
       0,     0,    14,     0,     0,     0,    15,     0,     0,     0,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,     0,     0,
       0,    34,    66,    67,    68,    69,    70,     0,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    66,
      67,    68,    69,    70,     0,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,     0,     0,     0,     0,
       0,    82,     0,    83,     0,   106,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    82,     0,
      83,     0,   128,    66,    67,    68,    69,    70,     0,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      66,    67,    68,    69,    70,     0,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,     0,     0,     0,
       0,     0,    82,     0,    83,     0,   129,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    82,
       0,    83,     0,   130,    66,    67,    68,    69,    70,     0,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    66,    67,    68,    69,    70,     0,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,     0,     0,
       0,     0,     0,    82,     0,    83,     0,   131,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      82,     0,    83,     0,   132,    66,    67,    68,    69,    70,
       0,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    66,    67,    68,    69,    70,     0,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,     0,
       0,     0,     0,     0,    82,     0,    83,     0,   133,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    82,     0,    83,     0,   134,    66,    67,    68,    69,
      70,     0,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    66,    67,    68,    69,    70,     0,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
       0,     0,     0,     0,     0,    82,     0,    83,     0,   135,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    82,     0,    83,     0,   136,    66,    67,    68,
      69,    70,     0,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    66,    67,    68,    69,    70,     0,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,     0,     0,     0,     0,     0,    82,     0,    83,     0,
     137,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    82,     0,    83,     0,   138,    66,    67,
      68,    69,    70,     0,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    66,    67,    68,    69,    70,
       0,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,     0,     0,     0,     0,     0,    82,     0,    83,
       0,   139,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    82,     0,    83,     0,   140,    66,
      67,    68,    69,    70,     0,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    66,    67,    68,    69,
      70,     0,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,     0,     0,     0,     0,     0,    82,     0,
      83,     0,   141,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    82,     0,    83,     0,   142,
      66,    67,    68,    69,    70,     0,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    66,    67,    68,
      69,    70,     0,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,     0,     0,     0,     0,     0,    82,
       0,    83,     0,   143,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    82,     0,    83,     0,
     144,    66,    67,    68,    69,    70,     0,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    66,    67,
      68,    69,    70,     0,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,     0,     0,    87,     0,     0,
      82,     0,    83,     0,   145,     0,    73,    74,    75,    76,
      77,    78,    79,    80,    81,     0,     0,    82,     0,    83,
      66,    67,    68,    69,    70,     0,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,   148,    83,
      66,    67,    68,    69,    70,     0,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,     0,     0,    82,
     150,    83,    66,    67,    68,    69,    70,     0,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
       0,    83,    68,    69,    70,     0,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,     0,     0,     0,
       0,    82,     0,    83,    69,    70,     0,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,     0,    82,
      70,    83,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    75,    76,    77,    78,    79,    80,    81,
      82,     0,    83,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,     0,    82,     0,    83,     0,     0,
       0,     0,    82,     0,    83,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    82,     0,    83
};

static const short yycheck[] =
{
      13,    14,    15,     7,    28,    29,    30,    31,    32,    55,
       5,    57,     4,     5,    14,    58,    58,    58,    58,    58,
      58,    34,    58,    58,    58,    38,    58,    58,    58,    58,
      58,    55,    58,    57,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    58,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      58,    58,    15,    57,    87,    30,    31,    32,    -1,    -1,
      -1,    -1,    86,    16,    17,    18,    19,    20,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      55,   114,    57,   116,     0,    -1,    -1,     3,     4,    -1,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    -1,
      -1,    -1,    55,    -1,    57,    21,    -1,    60,    -1,    -1,
      -1,    -1,    -1,    29,    -1,   148,    -1,    33,    -1,    -1,
      -1,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    -1,
       3,     4,    58,     6,    60,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    -1,    -1,    -1,    -1,    -1,    -1,    21,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    29,    -1,    -1,    -1,
      33,    -1,    -1,    -1,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    -1,     3,     4,    58,     6,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    29,
      -1,    -1,    -1,    33,    -1,    -1,    -1,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    -1,     3,     4,    58,     6,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    21,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    29,    -1,    -1,    -1,    33,    -1,    -1,    -1,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    -1,    -1,
      -1,    58,    16,    17,    18,    19,    20,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    16,
      17,    18,    19,    20,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    55,    -1,    57,    -1,    59,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    55,    -1,
      57,    -1,    59,    16,    17,    18,    19,    20,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      16,    17,    18,    19,    20,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    55,    -1,    57,    -1,    59,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    55,
      -1,    57,    -1,    59,    16,    17,    18,    19,    20,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    16,    17,    18,    19,    20,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    55,    -1,    57,    -1,    59,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      55,    -1,    57,    -1,    59,    16,    17,    18,    19,    20,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    16,    17,    18,    19,    20,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    55,    -1,    57,    -1,    59,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    55,    -1,    57,    -1,    59,    16,    17,    18,    19,
      20,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    16,    17,    18,    19,    20,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    55,    -1,    57,    -1,    59,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    55,    -1,    57,    -1,    59,    16,    17,    18,
      19,    20,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    16,    17,    18,    19,    20,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    55,    -1,    57,    -1,
      59,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    55,    -1,    57,    -1,    59,    16,    17,
      18,    19,    20,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    16,    17,    18,    19,    20,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    55,    -1,    57,
      -1,    59,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    55,    -1,    57,    -1,    59,    16,
      17,    18,    19,    20,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    16,    17,    18,    19,
      20,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    55,    -1,
      57,    -1,    59,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    55,    -1,    57,    -1,    59,
      16,    17,    18,    19,    20,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    16,    17,    18,
      19,    20,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    55,
      -1,    57,    -1,    59,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    55,    -1,    57,    -1,
      59,    16,    17,    18,    19,    20,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    16,    17,
      18,    19,    20,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    -1,    -1,    35,    -1,    -1,
      55,    -1,    57,    -1,    59,    -1,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    -1,    -1,    55,    -1,    57,
      16,    17,    18,    19,    20,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    55,    34,    57,
      16,    17,    18,    19,    20,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    -1,    -1,    55,
      36,    57,    16,    17,    18,    19,    20,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    55,
      -1,    57,    18,    19,    20,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      -1,    55,    -1,    57,    19,    20,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    -1,    55,
      20,    57,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    26,    27,    28,    29,    30,    31,    32,
      55,    -1,    57,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    -1,    55,    -1,    57,    -1,    -1,
      -1,    -1,    55,    -1,    57,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    55,    -1,    57
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    62,     0,     3,     4,     6,     7,     8,     9,    10,
      11,    12,    13,    21,    29,    33,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    58,    60,    63,    65,    14,     4,
       5,    64,    64,     4,    65,    65,    65,    58,    58,    58,
      58,    58,    58,    58,    58,    58,    58,    58,    58,    58,
      58,    58,    58,    58,    58,    65,    16,    17,    18,    19,
      20,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    55,    57,    60,    65,    15,    35,    65,    65,
      65,    65,    65,    65,    65,    65,    65,    65,    65,    65,
      65,    65,    65,    65,    65,    65,    59,    65,    65,    65,
      65,    65,    65,    65,    14,    65,    14,    65,    65,    65,
      65,    65,    65,    65,    65,    65,    64,    65,    59,    59,
      59,    59,    59,    59,    59,    59,    59,    59,    59,    59,
      59,    59,    59,    59,    59,    59,    65,    65,    34,    65,
      36
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1

/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylineno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 4:
#line 70 "h3calc-bison.y"
    {   return 0; ;}
    break;

  case 5:
#line 71 "h3calc-bison.y"
    { 	printf ("%.10g\n", yyvsp[-1].value); return 0;	;}
    break;

  case 6:
#line 72 "h3calc-bison.y"
    { 
        						dprintf ("assign: %s = %g\n", yyvsp[-2].name, yyvsp[0].value); 
        						setvar(yyvsp[-2].name, yyvsp[0].value, FALSE);
        						//printf ("\n");
        					;}
    break;

  case 7:
#line 77 "h3calc-bison.y"
    {	return 2;	;}
    break;

  case 8:
#line 78 "h3calc-bison.y"
    {
        						printf("\n--- variables ---\n");
        						int num=showvars();
        						printf("--- %d found ---\n\n",num);
        					;}
    break;

  case 9:
#line 83 "h3calc-bison.y"
    {
        						printf("\n--- constants ---\n");
        						int num=showconsts();
        						printf("--- %d found ---\n\n",num);
        					;}
    break;

  case 10:
#line 88 "h3calc-bison.y"
    {
        						printf("\n--- help ---\n");

                                printf(  " Here are some examples of what you can do:\n\n");
                                printf(  " > variables                          ... lists user defined vars\n");
                                printf(  " > constants                          ... lists predefined constants\n");
                                printf(  " > functions                          ... lists predefined functions\n");
                                printf(  " > help                               ... shows this help screen\n");
                                printf(  " > quit                               ... quits\n");
                                printf(  " > ln(1+(4+2)*3)+sin(pi*e)            ... outputs the result\n");
                                printf(  " > pippo = 6+round(cos(3)*10)         ... defines a variable \n");
                                printf(  " > pippo                              ... outputs a variable's value\n");
                                printf(  " > pluto = [ pippo<0 ? pippo : 0 ]    ... if ... then ... else ...\n");
                                printf(  " > fast and small or not expensive    ... fuzzy logic (vars in range 0..1)\n");
                                printf(  "\n Examples of what you can do in the 'read from file' mode:\n\n");
                                printf(  " > print \"any string\"                 ... prints to screen a string\n");
                                printf(  " > println                            ... goes to the next row\n");
                                printf(  " > println \"string\",var,\"string\"      ... prints strings and variables\n");
                                printf(  " > pippo = input                      ... asks to the user for a value\n");
                                printf(  "------------\n\n");
        					;}
    break;

  case 11:
#line 109 "h3calc-bison.y"
    {
        						printf("\n--- functions ---\n");
        						printf(  "abs and arccos arcsin arctan cbrt ceil cos cosh exp floor ln log\n");
								printf(  "not or round sin sinh sqrt tan tanh xor\n");
								printf(  "( ) + - * / %% [:?] ! ^ << >> < <= > >= == != => =<\n");
								printf(  "input print println\n");
								printf(  "quit exit help variables constants functions\n");
								printf(  "-----------------\n\n");
							;}
    break;

  case 12:
#line 118 "h3calc-bison.y"
    {	printf( "%s", yyvsp[0].name);		;}
    break;

  case 13:
#line 119 "h3calc-bison.y"
    { 	printf( "%s\n", yyvsp[0].name); 	;}
    break;

  case 14:
#line 120 "h3calc-bison.y"
    {	printf("\n");	;}
    break;

  case 15:
#line 124 "h3calc-bison.y"
    {   strcpynz(yyval.name,yyvsp[0].name,MAX_VARIABLE_NAME_LENGTH);		;}
    break;

  case 16:
#line 125 "h3calc-bison.y"
    {
        						struct variableinfo *v = getvar(yyvsp[0].name);
							   	if (v==NULL) {
							   		sprintf(yyval.name,"%.10g",0.0); 						
							   		printf("warning: variable \"%s\" undefined, assuming %s = 0\n",yyvsp[0].name,yyvsp[0].name); 
							   	} else {
							   		sprintf(yyval.name,"%.10g",v->value);
							   	}	
        					;}
    break;

  case 17:
#line 134 "h3calc-bison.y"
    {
        						strcpynz(yyval.name,yyvsp[-2].name,MAX_VARIABLE_NAME_LENGTH);
        						strcat(yyval.name,yyvsp[0].name);
        					;}
    break;

  case 18:
#line 140 "h3calc-bison.y"
    { yyval.value = yyvsp[0].value;  				dprintf("value: %g\n",yyvsp[0].value);	;}
    break;

  case 19:
#line 141 "h3calc-bison.y"
    { 
							   	struct variableinfo *v = getvar(yyvsp[0].name);
							   	if (v==NULL) {
							   		yyval.value = 0.0; 						
							   		printf("warning: variable \"%s\" undefined, assuming %s = 0\n",yyvsp[0].name,yyvsp[0].name); 
							   	} else {
							   		yyval.value = v->value;
							   		dprintf("var: \"%s\" has value %g\n",yyvsp[0].name,v->value); 
							   	}
						  	 ;}
    break;

  case 20:
#line 151 "h3calc-bison.y"
    {
								float temp;
								fscanf(stdin,"%g",&temp);
								yyval.value=temp;
							 ;}
    break;

  case 21:
#line 156 "h3calc-bison.y"
    { 
								if(yyvsp[-2].value<yyvsp[0].value) yyval.value=yyvsp[-2].value; else yyval.value=yyvsp[0].value;
								dprintf("and: %g and %g = %g\n",yyvsp[-2].value,yyvsp[0].value,yyval.value);	
							 ;}
    break;

  case 22:
#line 160 "h3calc-bison.y"
    { 
								if(yyvsp[-2].value>yyvsp[0].value) yyval.value=yyvsp[-2].value; else yyval.value=yyvsp[0].value;
								dprintf("or: %g or %g = %g\n",yyvsp[-2].value,yyvsp[0].value,yyval.value);	
							 ;}
    break;

  case 23:
#line 164 "h3calc-bison.y"
    { 
								double temp1 = (yyvsp[-2].value < 1.0-yyvsp[0].value) ? yyvsp[-2].value : 1.0-yyvsp[0].value ;
								double temp2 = (1.0-yyvsp[-2].value < yyvsp[0].value) ? 1.0-yyvsp[-2].value : yyvsp[0].value ;
								yyval.value = (temp1 > temp2) ? temp1 : temp2;
								dprintf("xor: %g or %g = %g\n",yyvsp[-2].value,yyvsp[0].value,yyval.value);	
							 ;}
    break;

  case 24:
#line 170 "h3calc-bison.y"
    { 
								yyval.value = (1.0-yyvsp[-2].value > yyvsp[0].value) ? 1.0-yyvsp[-2].value : yyvsp[0].value;
								dprintf("=>: %g => %g = %g\n",yyvsp[-2].value,yyvsp[0].value,yyval.value);	
							 ;}
    break;

  case 25:
#line 174 "h3calc-bison.y"
    { 
								yyval.value = (1.0-yyvsp[0].value > yyvsp[-2].value) ? 1.0-yyvsp[0].value : yyvsp[-2].value;
								dprintf("=>: %g => %g = %g\n",yyvsp[-2].value,yyvsp[0].value,yyval.value);	
							 ;}
    break;

  case 26:
#line 178 "h3calc-bison.y"
    { 
								yyval.value=1.0 - yyvsp[0].value; 
								dprintf("not: not %g = %g\n",yyvsp[0].value,yyval.value);	
							 ;}
    break;

  case 27:
#line 182 "h3calc-bison.y"
    { 
								yyval.value=floor(yyvsp[-2].value*pow(2,yyvsp[0].value));
								dprintf("<<: %g << %g = %g\n",yyvsp[-2].value,yyvsp[0].value,yyval.value);	
							 ;}
    break;

  case 28:
#line 186 "h3calc-bison.y"
    { 
								yyval.value=floor(yyvsp[-2].value/pow(2,yyvsp[0].value));
								dprintf(">>: %g >> %g = %g\n",yyvsp[-2].value,yyvsp[0].value,yyval.value);	
							 ;}
    break;

  case 29:
#line 190 "h3calc-bison.y"
    { 
								if(yyvsp[-2].value<yyvsp[0].value) yyval.value=1.0; else yyval.value=0.0;
								dprintf("<: %g < %g = %g\n",yyvsp[-2].value,yyvsp[0].value,yyval.value);	
							 ;}
    break;

  case 30:
#line 194 "h3calc-bison.y"
    { 
								if(yyvsp[-2].value>yyvsp[0].value) yyval.value=1.0; else yyval.value=0.0;
								dprintf(">: %g > %g = %g\n",yyvsp[-2].value,yyvsp[0].value,yyval.value);	
							 ;}
    break;

  case 31:
#line 198 "h3calc-bison.y"
    { 
								if(yyvsp[-3].value<=yyvsp[-1].value) yyval.value=1.0; else yyval.value=0.0;
								dprintf("<=: %g <= %g = %g\n",yyvsp[-3].value,yyvsp[-1].value,yyval.value);	
							 ;}
    break;

  case 32:
#line 202 "h3calc-bison.y"
    { 
								if(yyvsp[-3].value>=yyvsp[-1].value) yyval.value=1.0; else yyval.value=0.0;
								dprintf(">=: %g >= %g = %g\n",yyvsp[-3].value,yyvsp[-1].value,yyval.value);	
							 ;}
    break;

  case 33:
#line 206 "h3calc-bison.y"
    { 
								if(yyvsp[-2].value==yyvsp[0].value) yyval.value=1.0; else yyval.value=0.0;
								dprintf("==: %g == %g = %g\n",yyvsp[-2].value,yyvsp[0].value,yyval.value);	
							 ;}
    break;

  case 34:
#line 210 "h3calc-bison.y"
    { 
								if(yyvsp[-2].value!=yyvsp[0].value) yyval.value=1.0; else yyval.value=0.0;
								dprintf("!=: %g != %g = %g\n",yyvsp[-2].value,yyvsp[0].value,yyval.value);	
							 ;}
    break;

  case 35:
#line 214 "h3calc-bison.y"
    { yyval.value = yyvsp[-2].value + yyvsp[0].value;		dprintf("add: %g + %g = %g\n",yyvsp[-2].value,yyvsp[0].value,yyval.value);	;}
    break;

  case 36:
#line 215 "h3calc-bison.y"
    { yyval.value = yyvsp[-2].value - yyvsp[0].value; 		dprintf("sub: %g - %g = %g\n",yyvsp[-2].value,yyvsp[0].value,yyval.value);  ;}
    break;

  case 37:
#line 216 "h3calc-bison.y"
    { yyval.value = yyvsp[-2].value * yyvsp[0].value;		dprintf("mul: %g * %g = %g\n",yyvsp[-2].value,yyvsp[0].value,yyval.value);  ;}
    break;

  case 38:
#line 217 "h3calc-bison.y"
    { yyval.value = yyvsp[-2].value / yyvsp[0].value;		dprintf("div: %g / %g = %g\n",yyvsp[-2].value,yyvsp[0].value,yyval.value);  ;}
    break;

  case 39:
#line 218 "h3calc-bison.y"
    { yyval.value = fmod(yyvsp[-2].value,yyvsp[0].value);		dprintf("mod: %g % %g = %g\n",yyvsp[-2].value,yyvsp[0].value,yyval.value);  ;}
    break;

  case 40:
#line 219 "h3calc-bison.y"
    { yyval.value = -yyvsp[0].value;        		dprintf("neg: - %g = %g\n",yyvsp[0].value,yyval.value);  ;}
    break;

  case 41:
#line 220 "h3calc-bison.y"
    { yyval.value = pow(yyvsp[-2].value,yyvsp[0].value); 	dprintf("pow: %g ^ %g = %g\n",yyvsp[-2].value,yyvsp[0].value,yyval.value);  ;}
    break;

  case 42:
#line 221 "h3calc-bison.y"
    { 
        					   double difff=fabs( yyvsp[-1].value-(double)(rint( yyvsp[-1].value )) );
        					   if( difff < 0.000000001 ) {
        					   		yyval.value=fatt(rint( yyvsp[-1].value ));
        		                    dprintf("fatt: %g ! = %g\n",yyvsp[-1].value,yyval.value);  
        		               } else printf("*ERROR: %g !\n",yyvsp[-1].value);
                             ;}
    break;

  case 43:
#line 228 "h3calc-bison.y"
    { yyval.value = yyvsp[-1].value;         		dprintf("( ): ( %g )\n",yyvsp[-1]);  ;}
    break;

  case 44:
#line 229 "h3calc-bison.y"
    {
        									if(yyvsp[-5].value >= 0.5) yyval.value = yyvsp[-3].value;
        									else yyval.value = yyvsp[-1].value;
        									dprintf("[ ]: [ %g ? %g : %g ] = %g\n",yyvsp[-5].value,yyvsp[-3].value,yyvsp[-1].value,yyval.value); 
        								;}
    break;

  case 45:
#line 234 "h3calc-bison.y"
    { yyval.value = ceil ( yyvsp[-1].value ); 		dprintf("ceil: ceil( %g ) = %g\n",yyvsp[-1].value,yyval.value);  ;}
    break;

  case 46:
#line 235 "h3calc-bison.y"
    { yyval.value = floor ( yyvsp[-1].value ); 		dprintf("floor: floor( %g ) = %g\n",yyvsp[-1].value,yyval.value);  ;}
    break;

  case 47:
#line 236 "h3calc-bison.y"
    { yyval.value = rint ( yyvsp[-1].value ); 		dprintf("round: round( %g ) = %g\n",yyvsp[-1].value,yyval.value);  ;}
    break;

  case 48:
#line 237 "h3calc-bison.y"
    { yyval.value = exp ( yyvsp[-1].value ); 		dprintf("exp: exp( %g ) = %g\n",yyvsp[-1].value,yyval.value);  ;}
    break;

  case 49:
#line 238 "h3calc-bison.y"
    { yyval.value = fabs ( yyvsp[-1].value ); 		dprintf("abs: abs( %g ) = %g\n",yyvsp[-1].value,yyval.value);  ;}
    break;

  case 50:
#line 239 "h3calc-bison.y"
    { yyval.value = sin ( yyvsp[-1].value ); 		dprintf("sin: sin( %g ) = %g\n",yyvsp[-1].value,yyval.value);  ;}
    break;

  case 51:
#line 240 "h3calc-bison.y"
    { yyval.value = cos ( yyvsp[-1].value ); 		dprintf("cos: cos( %g ) = %g\n",yyvsp[-1].value,yyval.value);  ;}
    break;

  case 52:
#line 241 "h3calc-bison.y"
    { yyval.value = tan ( yyvsp[-1].value ); 		dprintf("tan: tan( %g ) = %g\n",yyvsp[-1].value,yyval.value);  ;}
    break;

  case 53:
#line 242 "h3calc-bison.y"
    { yyval.value = sinh ( yyvsp[-1].value ); 		dprintf("sinh: sinh( %g ) = %g\n",yyvsp[-1].value,yyval.value);  ;}
    break;

  case 54:
#line 243 "h3calc-bison.y"
    { yyval.value = cosh ( yyvsp[-1].value ); 		dprintf("cosh: cosh( %g ) = %g\n",yyvsp[-1].value,yyval.value);  ;}
    break;

  case 55:
#line 244 "h3calc-bison.y"
    { yyval.value = tanh ( yyvsp[-1].value ); 		dprintf("tanh: tanh( %g ) = %g\n",yyvsp[-1].value,yyval.value);  ;}
    break;

  case 56:
#line 245 "h3calc-bison.y"
    { yyval.value = asin ( yyvsp[-1].value ); 		dprintf("arcsin: arcsin( %g ) = %g\n",yyvsp[-1].value,yyval.value);  ;}
    break;

  case 57:
#line 246 "h3calc-bison.y"
    { yyval.value = acos ( yyvsp[-1].value ); 		dprintf("arccos: arccos( %g ) = %g\n",yyvsp[-1].value,yyval.value);  ;}
    break;

  case 58:
#line 247 "h3calc-bison.y"
    { yyval.value = atan ( yyvsp[-1].value ); 		dprintf("arctan: arctan( %g ) = %g\n",yyvsp[-1].value,yyval.value);  ;}
    break;

  case 59:
#line 248 "h3calc-bison.y"
    { if (yyvsp[-1].value>0) { 
        							yyval.value = sqrt ( yyvsp[-1].value ); 
        							dprintf("sqrt: sqrt( %g ) = %g\n",yyvsp[-1].value,yyval.value); 
        					   } else {
        					   	 	printf("*ERROR: sqrt( %g )\n",yyvsp[-1].value);
        					   }
        					 ;}
    break;

  case 60:
#line 255 "h3calc-bison.y"
    { if (yyvsp[-1].value>0) { 
        							yyval.value = cbrt ( yyvsp[-1].value ); 
        							dprintf("cbrt: cbrt( %g ) = %g\n",yyvsp[-1].value,yyval.value); 
        					   } else {
        					   	 	printf("*ERROR: cbrt( %g )\n",yyvsp[-1].value);
        					   }
        					 ;}
    break;

  case 61:
#line 262 "h3calc-bison.y"
    { if (yyvsp[-1].value>0) { 
        							yyval.value = log ( yyvsp[-1].value ); 
        							dprintf("ln: ln( %g ) = %g\n",yyvsp[-1].value,yyval.value); 
        					   } else {
        					   	 	printf("*ERROR: ln( %g )\n",yyvsp[-1].value);
        					   }
        					 ;}
    break;

  case 62:
#line 269 "h3calc-bison.y"
    { if (yyvsp[-1].value>0) { 
        							yyval.value = log10 ( yyvsp[-1].value ); 
        							dprintf("log: log( %g ) = %g\n",yyvsp[-1].value,yyval.value); 
        					   } else {
        					   	 	printf("*ERROR: log( %g )\n",yyvsp[-1].value);
        					   }
        					 ;}
    break;


    }

/* Line 991 of yacc.c.  */
#line 1798 "h3calc-bison.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("syntax error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab2;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:

  /* Suppress GCC warning that yyerrlab1 is unused when no action
     invokes YYERROR.  */
#if defined (__GNUC_MINOR__) && 2093 <= (__GNUC__ * 1000 + __GNUC_MINOR__)
  __attribute__ ((__unused__))
#endif


  goto yyerrlab2;


/*---------------------------------------------------------------.
| yyerrlab2 -- pop states until the error token can be shifted.  |
`---------------------------------------------------------------*/
yyerrlab2:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 277 "h3calc-bison.y"


int yyerror(char *s)  /* Chiamata da yyparse in caso di errore */
{
  printf("*ERROR: %s\n", s);
  fflush(stdin);
  return 1;
}

